package org.springblade.flow.form.controller;

import org.springblade.flow.base.ActionResult;
import org.springblade.flow.database.exception.DataException;
import org.springblade.flow.engine.enums.FlowStatusEnum;
import org.springblade.flow.exception.WorkFlowException;
import org.springblade.flow.form.entity.PostBatchTabEntity;
import org.springblade.flow.form.model.postbatchtab.PostBatchTabForm;
import org.springblade.flow.form.model.postbatchtab.PostBatchTabInfoVO;
import org.springblade.flow.form.service.PostBatchTabService;
import org.springblade.flow.util.JsonUtil;
import org.springblade.flow.util.JsonUtilEx;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * 发文呈批表
 *
 * @author JNPF开发平台组
 * @version V3.1.0
 * @copyright 引迈信息技术有限公司
 * @date 2019年9月29日 上午9:18
 */
@Api(tags = "发文呈批表", value = "PostBatchTab")
@RestController
@RequestMapping("/paas/workflow/Form/PostBatchTab")
public class PostBatchTabController {

	@Autowired
	private PostBatchTabService postBatchTabService;

	/**
	 * 获取发文呈批表信息
	 *
	 * @param id 主键值
	 * @return
	 */
	@ApiOperation("获取发文呈批表信息")
	@GetMapping("/{id}")
	public ActionResult<PostBatchTabInfoVO> info(@PathVariable("id") String id) throws DataException {
		PostBatchTabEntity entity = postBatchTabService.getInfo(id);
		PostBatchTabInfoVO vo = JsonUtilEx.getJsonToBeanEx(entity, PostBatchTabInfoVO.class);
		return ActionResult.success(vo);
	}

	/**
	 * 新建发文呈批表
	 *
	 * @param postBatchTabForm 表单对象
	 * @return
	 */
	@ApiOperation("新建发文呈批表")
	@PostMapping
	public ActionResult create(@RequestBody PostBatchTabForm postBatchTabForm) throws WorkFlowException {
		PostBatchTabEntity entity = JsonUtil.getJsonToBean(postBatchTabForm, PostBatchTabEntity.class);
		if (FlowStatusEnum.save.getMessage().equals(postBatchTabForm.getStatus())) {
			postBatchTabService.save(entity.getId(), entity);
			return ActionResult.success("保存成功");
		}
		postBatchTabService.submit(entity.getId(), entity);
		return ActionResult.success("提交成功，请耐心等待");
	}

	/**
	 * 修改发文呈批表
	 *
	 * @param postBatchTabForm 表单对象
	 * @param id               主键
	 * @return
	 */
	@ApiOperation("修改发文呈批表")
	@PutMapping("/{id}")
	public ActionResult update(@RequestBody PostBatchTabForm postBatchTabForm, @PathVariable("id") String id)
			throws WorkFlowException {
		PostBatchTabEntity entity = JsonUtil.getJsonToBean(postBatchTabForm, PostBatchTabEntity.class);
		if (FlowStatusEnum.save.getMessage().equals(postBatchTabForm.getStatus())) {
			postBatchTabService.save(id, entity);
			return ActionResult.success("保存成功");
		}
		postBatchTabService.submit(id, entity);
		return ActionResult.success("提交成功，请耐心等待");
	}
}
